#include <stdio.h>
#include <stdlib.h>

typedef struct node{
	int key;
	unsigned int leftidx, rightidx;
} row_t;

typedef struct {
	int max;  //total size
	int n;    //used size
	row_t *M; //array
} tree_t;

//adds new element to tree or ignores if already present
void add(int key, tree_t *t){
	int idx = 0;
	while(1){
		printf("%d: %d ", idx, t->M[idx].key);
		if(t->n <= idx){ //new element
			if(t->n < t->max){
				t->M[idx].key = key;
				t->M[idx].leftidx = t->M[idx].rightidx = 0; //not allowed to loop back to beginning
				t->n++;
				printf("added %d\n\n", key);
			}else
				printf("out of space for %d!\n\n", key); // or we could realloc here
			break;
		} else
		if(key < t->M[idx].key){
			printf("go left\n");
			if(t->M[idx].leftidx != 0)
				idx = t->M[idx].leftidx; // let's try left branch
			else
				idx = t->M[idx].leftidx = t->n; // nothing there, will be added next iteration
							
		} else
		if(key > t->M[idx].key){
			printf("go right\n");
			if(t->M[idx].rightidx != 0)
				idx = t->M[idx].rightidx; // let's try right branch
			else
				idx = t->M[idx].rightidx = t->n; // nothing there, will be added next iteration			
		} else
		if(key == t->M[idx].key){ // already present in tree
			printf("present %d\n\n", key);
			break;
		}
	}
}

//prints the entire tree, recursive
void print(tree_t *t, int idx, int level){
	//printf("print %d L:%d R:%d\n", idx, t->M[idx].leftidx, t->M[idx].rightidx);
	if(t->M[idx].leftidx != 0)
		print(t, t->M[idx].leftidx, level + 1);
	if(idx < t->n){
		printf("%*s%d\n", level * 4, "", t->M[idx].key);
		//printf("(%d): %d\n", level, t->M[idx].key);
	}
	if(t->M[idx].rightidx != 0)
		print(t, t->M[idx].rightidx, level + 1);
}

void print2(tree_t *t){
	int i;
	printf("\n");
	for(i = 0; i < t->n; i++)
		printf("%d: %d L:%d R:%d\n", i, t->M[i].key, t->M[i].leftidx, t->M[i].rightidx);
	printf("\n");
}

int main(void){
	int n;
	printf("How many: ");
	if(scanf("%d", &n) < 1 || n < 1)
		return 0;
	printf("----------------------------------------\n\n");
	tree_t tree;
	tree.max = n;
	tree.n = 0;
	tree.M = malloc(n * sizeof(row_t));
	if(tree.M == NULL){
		printf("Could not allocate memory.\n");
		return 0;
	}
	int k = n * 2;
	for(int i = 0; i < n; i++)
		add(rand() % k, &tree);	
	printf("Unique: %d\n", tree.n);
	print2(&tree);
	print(&tree, 0, 0);
	free(tree.M);
	return 0;
}
